package cz.zweistein.df.soundsense.gui.control;

import java.awt.GridLayout;
import java.awt.Label;

import javax.swing.JLabel;
import javax.swing.JPanel;

import cz.zweistein.df.soundsense.config.Sound;
import cz.zweistein.df.soundsense.output.sound.player.PlayerManager;

public class SoundInfoPanel extends JPanel {
	private static final long serialVersionUID = -6987634849512435047L;
	
	final JLabel soundInfoPatternLabel;
	final JLabel soundInfoChannelLabel;
	final JLabel soundInfoLoopLabel;
	final JLabel soundInfoTimeoutLabel;
	final JLabel soundInfoConcurencyLabel;
	final StartSoundPlaybackButton soundInfoPlayButton;

	public SoundInfoPanel(PlayerManager manager) {
		super();
		
        this.setLayout(new GridLayout(0,2));

        this.add(new Label("Pattern:"));
        soundInfoPatternLabel = new JLabel();
        this.add(soundInfoPatternLabel);
        
        this.add(new Label("Channel:"));
        soundInfoChannelLabel = new JLabel();
        this.add(soundInfoChannelLabel);
        
        this.add(new Label("Loop:"));
        soundInfoLoopLabel = new JLabel();
        this.add(soundInfoLoopLabel);
        
        this.add(new Label("Timeout:"));
        soundInfoTimeoutLabel = new JLabel();
        this.add(soundInfoTimeoutLabel);
        
        this.add(new Label("Concurency:"));
        soundInfoConcurencyLabel = new JLabel();
        this.add(soundInfoConcurencyLabel);
        
        this.add(new Label("Playback:"));
        soundInfoPlayButton = new StartSoundPlaybackButton(manager);
        this.add(soundInfoPlayButton);
	}

	public void updateSound(Sound sound) {
		soundInfoPatternLabel.setText(sound.getLogPattern());
		soundInfoChannelLabel.setText(sound.getChannel());
		soundInfoLoopLabel.setText(sound.getLoop()==null?"":sound.getLoop().toString());
		soundInfoTimeoutLabel.setText(sound.getTimeout()==null?"no timeout":sound.getTimeout()+"ms");
		soundInfoConcurencyLabel.setText(sound.getConcurency()==null?"no concurency":sound.getConcurency().toString());
		soundInfoPlayButton.setSound(sound);
	}

}
